----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:31:14 02/22/2014 
-- Design Name: 
-- Module Name:    ALU - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ALU is
    Port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           Op : in  STD_LOGIC_VECTOR (3 downto 0);
           Outp : out  STD_LOGIC_VECTOR (31 downto 0);
           Zero : out  STD_LOGIC;
           Cout : out  STD_LOGIC;
           Ovf : out  STD_LOGIC);
end ALU;

architecture Behavioral of ALU is

component add_sub
	port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           addsub : in  STD_LOGIC;
           Output : out  STD_LOGIC_VECTOR (31 downto 0);
           Cout : out  STD_LOGIC);
end component;


component Shifter
	port ( Input : in  STD_LOGIC_VECTOR (31 downto 0);
           Left_right : in  STD_LOGIC;
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component circ_rotate_right
    port ( Input : in  STD_LOGIC_VECTOR (31 downto 0);
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component circ_rotate_left
    port ( Input : in  STD_LOGIC_VECTOR (31 downto 0);
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end component;


signal output_adder 	 :std_logic_vector(31 downto 0);
signal output_and 	 :std_logic_vector(31 downto 0);
signal output_or 		 :std_logic_vector(31 downto 0);
signal output_not 	 :std_logic_vector(31 downto 0);
signal output_shifter :std_logic_vector(31 downto 0);
signal output_circ_rot_right :std_logic_vector(31 downto 0);
signal output_circ_rot_left :std_logic_vector(31 downto 0);
signal output_tmp :std_logic_vector(31 downto 0);
signal left_right,ovf_tmp,cout_tmp:std_logic;


begin


addr: add_sub
				port map (A=>A,
							 B=>B,
							 addsub=>(not Op(3)),
							 Output=>output_adder,
							 Cout=>cout_tmp);
shft: Shifter
				port map (Input=>A,
							 Left_right=>Op(2),
							 Output=>output_shifter);
crr: circ_rotate_right
				port map (Input=>A,
							 Output=>output_circ_rot_right);
							 
crl: circ_rotate_left
				port map (Input=>A,
							 Output=>output_circ_rot_left);

with Op select--elegxos ths eksodou (ti tha vgalei h alu)
			output_tmp<=output_adder when "1111",--prosthesh
			output_adder 	when "0111",--aferesh
			output_shifter when "1000",--shift deksia
			output_shifter when "1100",--shift aristera
			output_and		when "0011",--and
			output_or		when "0000",--or
			output_not		when "0001",--not
			output_circ_rot_right when "0101",
			output_circ_rot_left when "1110",
			A when others;
			
			
with Op(2 downto 0) select
			Ovf<=ovf_tmp when "111",
			'0' when others;
with Op(2 downto 0) select
			Cout<=cout_tmp when "111",
			'0' when others;
			
with output_tmp select --elegxos tou Zero flag
		  Zero<='1' when "00000000000000000000000000000000",
		  '0' when others;
		  
output_and<=A and B;
output_or<=A or B;
output_not<=not A;

ovf_tmp<=(A(31) and B(31) and (not output_tmp(31))) or ((not A(31)) and (not B(31)) and output_tmp(31));
Outp<=output_tmp;
end Behavioral;

