----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:59:55 03/11/2014 
-- Design Name: 
-- Module Name:    ALUSTAGE - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ALUSTAGE is
    Port ( RF_A : in  STD_LOGIC_VECTOR (31 downto 0);
           RF_B : in  STD_LOGIC_VECTOR (31 downto 0);
           Immed : in  STD_LOGIC_VECTOR (31 downto 0);
           ALU_Bin_sel : in  STD_LOGIC;
           ALU_func : in  STD_LOGIC_VECTOR (3 downto 0);
           ALU_out : out  STD_LOGIC_VECTOR (31 downto 0);
			  Zero : OUT std_logic;
			  Cout : OUT std_logic;
			  Ovf : OUT std_logic);
			  
end ALUSTAGE;

architecture Behavioral of ALUSTAGE is

COMPONENT mux_alu_stage
	PORT(
		input_rf : IN std_logic_vector(31 downto 0);
		input_imm : IN std_logic_vector(31 downto 0);
		slct : IN std_logic;          
		mux_out : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;
	
COMPONENT ALU
	PORT(
		A : IN std_logic_vector(31 downto 0);
		B : IN std_logic_vector(31 downto 0);
		Op : IN std_logic_vector(3 downto 0);          
		Outp : OUT std_logic_vector(31 downto 0);
		Zero : OUT std_logic;
		Cout : OUT std_logic;
		Ovf : OUT std_logic
		);
END COMPONENT;

signal mux_output:  STD_LOGIC_VECTOR (31 downto 0);


begin

muxAluSt: mux_alu_stage PORT MAP(
		input_rf => RF_B,
		input_imm => Immed,
		slct => ALU_Bin_sel,
		mux_out => mux_output
	);
	
Inst_ALU: ALU PORT MAP(
		A => RF_A,
		B => mux_output,
		Op => ALU_func,
		Outp => ALU_out,
		Zero => Zero,
		Cout => Cout,
		Ovf => Ovf
	);

end Behavioral;

