----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:48:16 03/08/2014 
-- Design Name: 
-- Module Name:    DECSTAGE - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DECSTAGE is
    Port ( Instr : in  STD_LOGIC_VECTOR (31 downto 0);
           RF_WrEn : in  STD_LOGIC;
           ALU_out : in  STD_LOGIC_VECTOR (31 downto 0);
           MEM_out : in  STD_LOGIC_VECTOR (31 downto 0);
			  from_adder :in std_logic_vector(31 downto 0);
           RF_WrData_sel : in  STD_LOGIC_vector(1 downto 0);
           RF_B_sel : in  STD_LOGIC;
			  var_addr :in std_logic_vector(4 downto 0); --store registers tha pernaei counter apo tn fsm
			  var_addr_act :in std_logic;--...elegxei an tha perasei normal timh h o counter
           Clk : in  STD_LOGIC;
			  Reset : in std_logic;
           Immed : out  STD_LOGIC_VECTOR (31 downto 0);
           RF_A : out  STD_LOGIC_VECTOR (31 downto 0);
           RF_B : out  STD_LOGIC_VECTOR (31 downto 0));
end DECSTAGE;

architecture Behavioral of DECSTAGE is

component RegFileTop
	port ( Ard1 : in  STD_LOGIC_VECTOR (4 downto 0);
           Ard2 : in  STD_LOGIC_VECTOR (4 downto 0);
           Awr : in  STD_LOGIC_VECTOR (4 downto 0);
           Dout1 : out  STD_LOGIC_VECTOR (31 downto 0);
           Dout2 : out  STD_LOGIC_VECTOR (31 downto 0);
           Din : in  STD_LOGIC_VECTOR (31 downto 0);
           WrEn : in  STD_LOGIC;
           Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC);
end component;

component immed_extend
	port ( instr : in  STD_LOGIC_VECTOR (15 downto 0);
           op_code : in  STD_LOGIC_VECTOR (5 downto 0);
           immed : out  STD_LOGIC_VECTOR (31 downto 0));
end component;


signal reg_B_addr :std_logic_vector(4 downto 0);
signal write_data :std_logic_vector(31 downto 0);
signal imm :std_logic_vector(31 downto 0);

signal reg_B_sr :std_logic_vector(4 downto 0);



begin

rf0: RegFileTop
					port map (Ard1=>Instr(25 downto 21),
								 Ard2=>reg_B_sr,
								 Awr=>Instr(20 downto 16),
								 Dout1=>RF_A,
								 Dout2=>RF_B,
								 Din=>write_data,
								 WrEn=>RF_WrEn,
								 Clock=>Clk,
								 Reset=>Reset
								 );
imex0: immed_extend --sign extension/zero fill
					port map (instr=>instr(15 downto 0),
								 op_code=>instr(31 downto 26),
								 immed=>imm
								 );

with RF_B_sel select --polyplekths gia epilogh dieythinshs vash format
				reg_B_addr<=Instr(15 downto 11) when '0',
				Instr(20 downto 16) when '1',
				Instr(15 downto 11) when others;


with var_addr_act select
				reg_B_sr<=reg_B_addr when '0',
				var_addr when '1';


with RF_WrData_sel select --polyplekths gia epilogh phghs gia grapsimo sthn RF
				write_data<=ALU_out when "00",-- apo alu
				MEM_out when "01",--apo mnhmh
				imm when "10",
				from_adder when "11",
				ALU_out when others;
Immed<=imm;	
end Behavioral;

