----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:58:55 03/21/2014 
-- Design Name: 
-- Module Name:    DpathTop - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DpathTop is
    Port ( PC_sel : in  STD_LOGIC;
           PC_LdEn : in  STD_LOGIC;
           Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC;
           Zero : out  STD_LOGIC;
			  lt : out std_logic;
           RF_B_sel : in  STD_LOGIC;
           RF_wr_sel : in  STD_LOGIC_VECTOR (1 downto 0);
           ALU_Bin_sel : in  STD_LOGIC;
			  ld_type_sel : in std_logic;
			  addle_crtl : in std_logic;
			  imm_or_zero :in std_logic;
			  equal : out std_logic;
			  addr_sel :in std_logic_vector(1 downto 0);
			  reg_immed : in std_logic;
			  var_addr : in std_logic_vector(4 downto 0);
			  var_addr_act : in std_logic;
			  mem_var :in std_logic_vector(31 downto 0);
           --ALU_func : in  STD_LOGIC_VECTOR (3 downto 0);
           Mem_datain_sel : in  STD_LOGIC;
           Mem_dataout_sel : in  STD_LOGIC;
           Mem_WrEn : in  STD_LOGIC;
			  instr_out :out std_logic_vector(31 downto 0);
           RF_WrEn : in  STD_LOGIC);
end DpathTop;

architecture Behavioral of DpathTop is

component IFSTAGE
	port ( PC_Immed : in  STD_LOGIC_VECTOR (31 downto 0);
           PC_sel : in  STD_LOGIC;
			  reg : in std_logic_vector(31 downto 0);
			  reg_immed : in std_logic;
           PC_LdEn : in  STD_LOGIC;
           Reset : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           Instr : out  STD_LOGIC_VECTOR (31 downto 0));
end component;


component DECSTAGE
	port ( Instr : in  STD_LOGIC_VECTOR (31 downto 0);
           RF_WrEn : in  STD_LOGIC;
           ALU_out : in  STD_LOGIC_VECTOR (31 downto 0);
           MEM_out : in  STD_LOGIC_VECTOR (31 downto 0);
			  from_adder : in std_logic_vector(31 downto 0);
           RF_WrData_sel : in  STD_LOGIC_vector(1 downto 0);
           RF_B_sel : in  STD_LOGIC;
			  var_addr :in std_logic_vector(4 downto 0); --store registers tha pernaei counter apo tn fsm
			  var_addr_act :in std_logic;--...elegxei an tha perasei normal timh h o counter
           Clk : in  STD_LOGIC;
			  Reset : in std_logic;
           Immed : out  STD_LOGIC_VECTOR (31 downto 0);
           RF_A : out  STD_LOGIC_VECTOR (31 downto 0);
           RF_B : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component ALUSTAGE-- h alu me ton mux ths
	port ( RF_A : in  STD_LOGIC_VECTOR (31 downto 0);
           RF_B : in  STD_LOGIC_VECTOR (31 downto 0);
           Immed : in  STD_LOGIC_VECTOR (31 downto 0);
           ALU_Bin_sel : in  STD_LOGIC;
           ALU_func : in  STD_LOGIC_VECTOR (3 downto 0);
           ALU_out : out  STD_LOGIC_VECTOR (31 downto 0);
			  Zero : OUT std_logic;
			  Cout : OUT std_logic;
			  Ovf : OUT std_logic);
end component;

component MEMSTAGE
	port ( clk : in  STD_LOGIC;
           Mem_WrEn : in  STD_LOGIC;
           ALU_MEM_Addr : in  STD_LOGIC_VECTOR (31 downto 0);
           MEM_DataIn : in  STD_LOGIC_VECTOR (31 downto 0);
           MEM_DataOut : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component add_sub
 Port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           addsub : in  STD_LOGIC;
           Output : out  STD_LOGIC_VECTOR (31 downto 0);
           Cout : out  STD_LOGIC);
end component;

component comparator is
    port ( A : in  STD_LOGIC_VECTOR (31 downto 0);
           B : in  STD_LOGIC_VECTOR (31 downto 0);
           equal : out  STD_LOGIC);
end component;


signal Immediate :std_logic_vector(31 downto 0); --edw pataei oti xreiazetai immediate
signal Instruction :std_logic_vector(31 downto 0); --... oti xreiazetai entolh
signal ALU_out :std_logic_vector(31 downto 0);-- pataei panw sthn eksodo ths alu
signal MEM_out :std_logic_vector(31 downto 0);-- pataei panw sthn eksodo ths mnhmhs

signal from_lbBO_mux :std_logic_vector(31 downto 0);--eksodos mux gia lbBO

signal rf_out_a :std_logic_vector(31 downto 0); --eksodos a reg file
signal rf_out_b :std_logic_vector(31 downto 0); --eksodos b reg file

signal from_mux_in,to_mux_out :std_logic_vector(31 downto 0);

signal dummy_cout,dummy_ovf,dummy_cout2,dummy3 :std_logic;


signal addle_ctrl_out :std_logic_vector(3 downto 0);

signal from_mux_out :std_logic_vector(31 downto 0);
signal ALU_func :std_logic_vector(3 downto 0);


--signal imm_or_zero :std_logic;--gia thn addmem
signal to_old_imm_in :std_logic_vector(31 downto 0);
signal to_old_alu_out_in :std_logic_vector(31 downto 0);
signal from_adder :std_logic_vector(31 downto 0);


signal mem_address :std_logic_vector(31 downto 0);

signal to_var_mem :std_logic_vector(31 downto 0);

begin

ifstg0: IFSTAGE
					port map (PC_Immed=>Immediate(29 downto 0) & "00",
								 PC_sel=>PC_sel,
								 reg=>rf_out_b,
								 reg_immed=>reg_immed,
								 PC_LdEn=>PC_LdEn,
								 Reset=>Reset,
								 Clk=>Clock,
								 Instr=>Instruction
								 );
dcstg0: DECSTAGE
					port map (Instr=>Instruction,
								 RF_WrEn=>RF_WrEn,
								 ALU_out=>ALU_out,--ALU_out,
								 MEM_out=>MEM_out,
								 from_adder=>from_adder,
								 RF_WrData_sel=>RF_wr_sel,
								 RF_B_sel=>RF_B_sel,
								 var_addr=>var_addr,
								 var_addr_act=>var_addr_act,
								 Clk=>Clock,
								 Reset=>Reset,
								 Immed=>Immediate,
								 RF_A=>rf_out_a,
								 RF_B=>rf_out_b
								 );

alustg0: ALUSTAGE
					port map (RF_A=>rf_out_a,
								 RF_B=>rf_out_b,
								 Immed=>to_old_imm_in,--egine allagh gia to addmem
								 ALU_Bin_sel=>ALU_Bin_sel,
								 ALU_func=>ALU_func,
								 ALU_out=>ALU_out,
								 Zero=>Zero,
								 Cout=>dummy_cout,
								 Ovf=>dummy_ovf
								 );
mmstg0: MEMSTAGE
					port map (clk=>Clock,
								 Mem_WrEn=>Mem_WrEn,
								 ALU_MEM_Addr=>mem_address,
								 MEM_DataIn=>from_mux_in,
								 MEM_DataOut=>to_mux_out
								 );
								 
													 
addrr0: add_sub
					port map (A=>to_mux_out, 
								 B=>rf_out_b,--RF[rd] Rf_b_sel=rd
								 addsub=>'0',
								 Output=>from_adder,
								 Cout=>dummy_cout2
								 );
								 
addrr1: add_sub 
				  port map (A=>to_stdlogicvector(to_bitvector(mem_var) sll 2),
								B=>Immediate,
								addsub=>'0',
								Output=>to_var_mem,
								Cout=>dummy3
								);
comp0: comparator
					port map (A=>to_mux_out,
							    B=>rf_out_a,
								 equal=>equal
								 );


with Mem_datain_sel select
					from_mux_in<=rf_out_b when '0',
					"000000000000000000000000" & rf_out_b(7 downto 0) when '1',--gia sb
					rf_out_b when others;
					
with  Mem_dataout_sel select
					from_mux_out<=to_mux_out when '0',
					"000000000000000000000000" & to_mux_out(7 downto 0) when '1',--gia lb
					to_mux_out when others;
instr_out<=Instruction;


--edw tha bei mux gia epilogh normal load(lw/lb) h lbBO
--bhke...
with ld_type_sel select
					MEM_out<=from_mux_out when '0',
					from_lbBO_mux when '1',
					from_mux_out when others;

--edw tha bei mux gia epilogh me vash to ALU_out (ALU_MEM_addr) 
--vsk me to ALU_out(1 downto 0); p tha epilegei poio byte tha
--krathsei apo ta 4 ths 32 biths lekshs

--bhke...
with ALU_out(1 downto 0) select
				from_lbBO_mux<="000000000000000000000000" & to_mux_out(7 downto 0) when "00",
				"000000000000000000000000" & to_mux_out(15 downto 8) when "01",
				"000000000000000000000000" & to_mux_out(23 downto 16) when "10",
				"000000000000000000000000" & to_mux_out(31 downto 24) when "11",
				"000000000000000000000000" & to_mux_out(7 downto 0) when others;

--eksodos ram->to_mux_out


lt<=ALU_out(31);--shma less than


--edw tha bei mux gia thn epilogh prostheshs me immediate h me to 0 (oste na perasei mesa apo thn alu o rs)
--+ mux gia na epilegei metaksy adder k alu out

--imm_or_zero :std_logic;--gia thn addmem
--to_old_imm_in :std_logic_vector(31 downto 0);


with imm_or_zero select --gia tn add_mem
						to_old_imm_in<=Immediate when '0',
						"00000000000000000000000000000000" when '1';

--mux p epilegei thn dieythinsh ths mnhmhs gia branchregmem

with addr_sel select 
						mem_address<=ALU_out when "00",
						to_stdlogicvector(to_bitvector(Immediate) sll 2) when "01",
						to_var_mem when "10",
						ALU_out when others;

--NA VALOUME CASES GIA TIS EXTRA ENTOLES!!!!
with Instruction(31 downto 26) select
					ALU_func<=Instruction(4 downto 1) when "100000",
					addle_ctrl_out when "100011",
					"1111" when "111000",
					"0011" when "111100",
					"0000" when "111110",
					"0111" when "000000",
					"0111" when "000001",
					"1111" when "000011",
					"1111" when	"000111",
					"1111" when	"001111",
					"1111" when	"011111",
					"1111" when "100001",
					"1111" when "100111",
					"1111" when others;
					
with addle_crtl select --gia tis faseis ekteleshs ths addle
				addle_ctrl_out<="0111" when '1',--aferesh
				"1111" when '0',--prosthesh
				"1111" when others;
				
				
end Behavioral;

