----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:03:30 03/11/2014 
-- Design Name: 
-- Module Name:    IFSTAGE - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity IFSTAGE is
    Port ( PC_Immed : in  STD_LOGIC_VECTOR (31 downto 0);
           PC_sel : in  STD_LOGIC;
			  reg : in std_logic_vector(31 downto 0);
			  reg_immed : in std_logic;
           PC_LdEn : in  STD_LOGIC;
           Reset : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           Instr : out  STD_LOGIC_VECTOR (31 downto 0));
end IFSTAGE;

architecture Behavioral of IFSTAGE is

COMPONENT IF_MEM
	PORT(
		clk : IN std_logic;
		addr : IN std_logic_vector(9 downto 0);          
		dout : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;

COMPONENT addresser
	PORT(
		PC_Immed : IN std_logic_vector(31 downto 0);
		PC_sel : IN std_logic;
		reg : in std_logic_vector(31 downto 0);
		reg_immed : in std_logic;
		PC_LdEn : IN std_logic;
		Reset : IN std_logic;
		Clk : IN std_logic;          
		Addr : OUT std_logic_vector(9 downto 0)
		);
END COMPONENT;

signal address :std_logic_vector(9 downto 0);

begin

Inst_IF_MEM: IF_MEM PORT MAP(
		clk =>Clk,
		addr =>address,
		dout =>Instr
	);
	
Inst_addresser: addresser PORT MAP(
		PC_Immed =>PC_Immed,
		reg=>reg,
		reg_immed=>reg_immed,
		PC_sel =>PC_sel,
		PC_LdEn =>PC_LdEn,
		Reset =>Reset,
		Clk =>Clk,
		Addr =>address
	);


end Behavioral;

