----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:16:40 02/26/2014 
-- Design Name: 
-- Module Name:    RegFileTop - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity RegFileTop is
    Port ( Ard1 : in  STD_LOGIC_VECTOR (4 downto 0);
           Ard2 : in  STD_LOGIC_VECTOR (4 downto 0);
           Awr : in  STD_LOGIC_VECTOR (4 downto 0);
           Dout1 : out  STD_LOGIC_VECTOR (31 downto 0);
           Dout2 : out  STD_LOGIC_VECTOR (31 downto 0);
           Din : in  STD_LOGIC_VECTOR (31 downto 0);
           WrEn : in  STD_LOGIC;
           Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC);
end RegFileTop;

architecture Behavioral of RegFileTop is

component regarray
	port ( Ard1 : in  STD_LOGIC_VECTOR (4 downto 0);
           Ard2 : in  STD_LOGIC_VECTOR (4 downto 0);
           WES : in  STD_LOGIC_VECTOR (31 downto 0);
           Din : in  STD_LOGIC_VECTOR (31 downto 0);
           Output1 : out  STD_LOGIC_VECTOR (31 downto 0);
           Output2 : out  STD_LOGIC_VECTOR (31 downto 0);
           Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC);
end component;

component Decoder
	port ( Input : in  STD_LOGIC_VECTOR (4 downto 0);
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component Mux322
	port ( selct : in  STD_LOGIC;
           In_true : in  STD_LOGIC_VECTOR (31 downto 0);
           In_false : in  STD_LOGIC_VECTOR (31 downto 0);
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component and_gates
	port ( from_decoder : in  STD_LOGIC_VECTOR (31 downto 0);
           from_we : in  STD_LOGIC;
           to_regarr : out  STD_LOGIC_VECTOR (31 downto 0));
end component;

component compare
   port ( Adr : in  STD_LOGIC_VECTOR (4 downto 0);
           Wadr : in  STD_LOGIC_VECTOR (4 downto 0);
           WrEn : in  STD_LOGIC;
           isEq : out  STD_LOGIC);
end component;

signal decoder_output:  STD_LOGIC_VECTOR (31 downto 0);
signal and_output:  STD_LOGIC_VECTOR (31 downto 0);
signal regarr_output1:  STD_LOGIC_VECTOR (31 downto 0);
signal regarr_output2:  STD_LOGIC_VECTOR (31 downto 0);
signal isEq1: STD_LOGIC;
signal isEq2: STD_LOGIC;

begin
dec: Decoder PORT MAP
		(Input=>Awr,
		 Output=>decoder_output);
		
and_g: and_gates PORT MAP
		(from_decoder=> decoder_output,
		 from_we=>WrEn,
		 to_regarr=>and_output);
		 
regs: regarray PORT MAP
		(Ard1=>Ard1,
		 Ard2=>Ard2,
		 WES=>and_output,
		 Din=>Din,
		 Output1=>regarr_output1,
		 Output2=>regarr_output2,
		 Clock=>Clock,
		 Reset=>Reset);

comp1: compare PORT MAP
		(Adr=>Ard1,
		 Wadr=>Awr,
		 WrEn=>WrEn,
		 isEq=>isEq1);
		 
comp2: compare PORT MAP
		(Adr=>Ard2,
		 Wadr=>Awr,
		 WrEn=>WrEn,
		 isEq=>isEq2);
		 
mux1: MUX322 PORT MAP
		(selct=>isEq1,
       In_true=>Din,
       In_false=>regarr_output1,
       Output=>Dout1);
		 
mux2: MUX322 PORT MAP
		(selct=>isEq2,
       In_true=>Din,
       In_false=>regarr_output2,
       Output=>Dout2);
		 		 
		 


end Behavioral;

