----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    00:14:31 02/23/2014 
-- Design Name: 
-- Module Name:    Shifter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;


-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Shifter is
    Port ( Input : in  STD_LOGIC_VECTOR (31 downto 0);
           Left_right : in  STD_LOGIC;
           Output : out  STD_LOGIC_VECTOR (31 downto 0));
end Shifter;

architecture Behavioral of Shifter is
signal left_s:bit_vector(31 downto 0);
signal right_s:bit_vector(31 downto 0);
signal left_sv:std_logic_vector(31 downto 0);
signal right_sv:std_logic_vector(31 downto 0);

begin
left_s<=to_bitvector(Input) sll 1;
right_s<=to_bitvector(Input) srl 1;

left_sv<=to_stdlogicvector(left_s);
right_sv<=to_stdlogicvector(right_s);

with Left_right select
		Output<=left_sv when '1',
		right_sv when '0',
		Input when others;



end Behavioral;

