----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:47:34 03/10/2014 
-- Design Name: 
-- Module Name:    addresser - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity addresser is
    Port ( PC_Immed : in  STD_LOGIC_VECTOR (31 downto 0);
			  reg : in std_logic_vector(31 downto 0);
			  reg_immed :in std_logic;
           PC_sel : in  STD_LOGIC;
           PC_LdEn : in  STD_LOGIC;
           Reset : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           Addr : out  STD_LOGIC_VECTOR (9 downto 0));
end addresser;

architecture Behavioral of addresser is

COMPONENT RegisterTop
	PORT(
		Data : IN std_logic_vector(31 downto 0);
		WE : IN std_logic;
		Clock : IN std_logic;
		Reset : IN std_logic;          
		Dout : OUT std_logic_vector(31 downto 0)
		);
END COMPONENT;

COMPONENT Summer_32
	PORT(
		A : IN std_logic_vector(31 downto 0);
		B : IN std_logic_vector(31 downto 0);
		Cin : IN std_logic;          
		Sum : OUT std_logic_vector(31 downto 0);
		Cout : OUT std_logic
		);
END COMPONENT;

signal mux_out,pc_out:std_logic_vector(31 downto 0);
signal incr_out,immed_adder_out:std_logic_vector(31 downto 0);

signal immed_or_reg :std_logic_vector(31 downto 0);

signal dummy1,dummy2 :std_logic;
begin

Inst_RegisterTop: RegisterTop PORT MAP(
		Data =>mux_out,
		Dout =>pc_out,
		WE =>PC_LdEn,
		Clock =>Clk,
		Reset =>Reset 
	);
	
Inst_Summer_32_incr: Summer_32 PORT MAP(
		A =>pc_out,
		B =>"00000000000000000000000000000100",
		Cin =>'0',
		Sum =>incr_out,
		Cout =>dummy1 
	);
	
Inst_Summer_32: Summer_32 PORT MAP(
		A =>incr_out,
		B => immed_or_reg, --PC_Immed(29 downto 0) & "00",--to_stdlogicvector(to_bitvector(PC_Immed) sll 2),
		Cin =>'0',
		Sum =>immed_adder_out
		--Cout =>dummy2
	);
with PC_sel	select
				mux_out<=incr_out when '0',
				immed_adder_out when '1',
				incr_out when others;

with reg_immed select
					immed_or_reg<=PC_Immed when '0',
					reg when '1';


Addr<=pc_out(11 downto 2);
end Behavioral;

