----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:59:42 03/26/2014 
-- Design Name: 
-- Module Name:    processor - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity processor is
    Port ( Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC);
end processor;

architecture Behavioral of processor is

COMPONENT DpathTop
	PORT(
		PC_sel : IN std_logic;
		PC_LdEn : IN std_logic;
		Clock : IN std_logic;
		Reset : IN std_logic;
		RF_B_sel : IN std_logic;
		RF_wr_sel : IN std_logic_vector(1 downto 0);
		ALU_Bin_sel : IN std_logic;
		ld_type_sel : in std_logic;
		addle_crtl : in std_logic;
		imm_or_zero : in std_logic; --addmem
		equal : out std_logic;--beqregmem
		addr_sel :in std_logic_vector(1 downto 0);--..to idio
		reg_immed : in std_logic;--to idio
		var_addr : in std_logic_vector(4 downto 0);--metavalei tis dieythinseis sth mnhmh
		var_addr_act : in std_logic;--energopoiei ton polyplekth p epilegei to rb_B_out metaksy normal (rt/rd kai metavalomenhs timhs)
		mem_var :in std_logic_vector(31 downto 0);--counter p ayksanei apo immediate k panw 
		Mem_datain_sel : IN std_logic;
		Mem_dataout_sel : IN std_logic;
		Mem_WrEn : IN std_logic;
		RF_WrEn : IN std_logic;          
		Zero : OUT std_logic;
		lt :out std_logic;-- gia to addle apo to datapath
		instr_out : OUT std_logic_vector(31 downto 0)
		);
	END COMPONENT;
	
	COMPONENT CNTRL
	PORT(
		Clock : IN std_logic;
		Reset : IN std_logic;
		Zero : IN std_logic;
		lt :in std_logic;-- gia to addle apo to datapath
		PC_sel : OUT std_logic;
		PC_LdEn : OUT std_logic;
		RF_B_sel : OUT std_logic;
		RF_wr_sel : OUT std_logic_vector(1 downto 0);
		ALU_Bin_sel : OUT std_logic;
		ld_type_sel : out std_logic;
		addle_crtl : out std_logic;
		imm_or_zero : out std_logic; --addmem
		equal : in std_logic;--beqregmem
		addr_sel :out std_logic_vector(1 downto 0);--..to idio
		reg_immed : out std_logic;--to idio	
		var_addr : out std_logic_vector(4 downto 0);--metavalei tis dieythinseis sth mnhmh
		var_addr_act : out std_logic;--energopoiei ton polyplekth p epilegei to rb_B_out metaksy normal (rt/rd kai metavalomenhs timhs)
		mem_var :out std_logic_vector(31 downto 0);--counter p ayksanei apo immediate k panw 
		Mem_datain_sel : OUT std_logic;
		Mem_dataout_sel : OUT std_logic;
		Mem_WrEn : OUT std_logic;
		instr : in std_logic_vector(31 downto 0);
		RF_WrEn : OUT std_logic
		);
	END COMPONENT;


signal PC_sel,PC_LdEn :std_logic;
signal zero :std_logic;

signal RF_B_sel :std_logic;
signal RF_wr_sel :std_logic_vector(1 downto 0);

signal ld_type_select :std_logic;
signal addle_crtl :std_logic;

signal lt :std_logic;


signal ALU_Bin_sel :std_logic;

signal MEM_datain_sel,MEM_dataout_sel :std_logic;
signal MEM_WrEn :std_logic;
signal RF_WrEn :std_logic;
signal instr :std_logic_vector(31 downto 0);

signal imm_or_zero : std_logic; --addmem
signal addmem : std_logic;--addmem  

signal equal : std_logic;--beqregmem
signal addr_sel : std_logic_vector(1 downto 0);--..to idio
signal reg_immed : std_logic;--to idio	

signal var_addr :  std_logic_vector(4 downto 0);--metavalei tis dieythinseis sth mnhmh
signal var_addr_act :  std_logic;--energopoiei ton polyplekth p epilegei to rb_B_out metaksy normal (rt/rd kai metavalomenhs timhs)
signal mem_var : std_logic_vector(31 downto 0);--counter p ayksanei apo immediate k panw 


begin


Inst_DpathTop: DpathTop PORT MAP(
		PC_sel =>PC_sel,
		PC_LdEn =>PC_LdEn,
		Clock =>Clock,
		Reset =>Reset,
		Zero =>zero,
		lt=>lt,
		RF_B_sel =>RF_B_sel,
		RF_wr_sel =>RF_wr_sel,
		ALU_Bin_sel =>ALU_Bin_sel ,
		ld_type_sel=>ld_type_select,
		addle_crtl=>addle_crtl,
		imm_or_zero=>imm_or_zero,
		equal=>equal, 
		addr_sel=> addr_sel,
		reg_immed =>reg_immed,
		
		var_addr=>var_addr,
		var_addr_act=>var_addr_act,
		mem_var=>mem_var, 
		Mem_datain_sel =>Mem_datain_sel ,
		Mem_dataout_sel =>Mem_dataout_sel ,
		Mem_WrEn =>Mem_WrEn ,
		instr_out =>instr ,
		RF_WrEn =>RF_WrEn 
	);

Inst_CNTRL: CNTRL PORT MAP(
		PC_sel =>PC_sel ,
		PC_LdEn =>PC_LdEn ,
		Clock =>Clock ,
		Reset =>Reset ,
		Zero =>zero ,
		lt=>lt,
		RF_B_sel =>RF_B_sel ,
		RF_wr_sel =>RF_wr_sel ,
		ALU_Bin_sel =>ALU_Bin_sel ,
		ld_type_sel=>ld_type_select,
		addle_crtl=>addle_crtl,
		imm_or_zero=>imm_or_zero,
		equal=>equal, 
		addr_sel=> addr_sel,
		reg_immed =>reg_immed,
		var_addr=>var_addr,
		var_addr_act=>var_addr_act,
		mem_var=>mem_var, 
		Mem_datain_sel =>Mem_datain_sel ,
		Mem_dataout_sel =>Mem_dataout_sel ,
		Mem_WrEn =>Mem_WrEn ,
		instr =>instr,
		RF_WrEn =>RF_WrEn 
	);

end Behavioral;

