----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:11:08 02/26/2014 
-- Design Name: 
-- Module Name:    regarray - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;
use IEEE.std_logic_unsigned.all;
-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity regarray is
    Port ( Ard1 : in  STD_LOGIC_VECTOR (4 downto 0);
           Ard2 : in  STD_LOGIC_VECTOR (4 downto 0);
           WES : in  STD_LOGIC_VECTOR (31 downto 0);
           Din : in  STD_LOGIC_VECTOR (31 downto 0);
           Output1 : out  STD_LOGIC_VECTOR (31 downto 0);
           Output2 : out  STD_LOGIC_VECTOR (31 downto 0);
           Clock : in  STD_LOGIC;
           Reset : in  STD_LOGIC);
end regarray;

architecture Behavioral of regarray is

component RegisterTop
	port ( Data : in  STD_LOGIC_VECTOR (31 downto 0);
           Dout : out  STD_LOGIC_VECTOR (31 downto 0);
           WE : in  STD_LOGIC;
			  Clock : in std_logic;
           Reset : in  STD_LOGIC);
end component;

type outputs is array(0 to 31) of std_logic_vector(31 downto 0);
signal Douts :outputs;


begin

reg0: RegisterTop
				port map(Data=>"00000000000000000000000000000000",
							Dout=>Douts(0),
							WE=>WES(0),
							Clock=>Clock,
							Reset=>Reset);


lbl: for I in 1 to 31 generate

reg: RegisterTop
				port map(Data=>Din,
							Dout=>Douts(I),
							WE=>WES(I),
							Clock=>Clock,
							Reset=>Reset);

end generate lbl;


Output1<=Douts(CONV_INTEGER(Ard1));
Output2<=Douts(CONV_INTEGER(Ard2));

end Behavioral;

